/*******************(C) COPYRIGHT 2019 Masses-Chip ******************************
* File Name          : MAIN.C
* Author             : MASSES CHIP
* Version            : V1.02
* Date               : 2019/04/18
********************************************************************************

 16M/4T, WDT EN 72MS, RST IS IO ,BOR 2.4V,RST TIMER 18MS

*******************************************************************************/





//===============================================================================
#include "M8P625.h"
#include "MassesChip_Define.h"

//===============================================================================

//====================================================================
// T0 BASE TIME  SET
#define	T0_125_US                    125
#define T0_LOAD_C_Init	            (T0_125_US*16000000/16/1000000)  //FOSC 1:16

#define T_500US_C_Init_DF            4
#define T_10MS_C_Init_DF             20


ob8 R_Time_Flag;
#define	bT_125UF_F    R_Time_Flag.b0
#define	bT_500US_F    R_Time_Flag.b1
#define	bT_10MS_F     R_Time_Flag.b2

unsigned char R_500US_COUNT  ;
unsigned char R_10MS_COUNT  ;


//===============================================================================


//===============================================================================
void InitalRAM(void);
void IO_Init(void);
void T0_Init(void);

//===============================================================================
void main(void)
{
  IO_Init();
  InitalRAM();
  T0_Init();
  GIE =1;
  while(1)
  {
    __CLRWDT();

  }
}

//===============================================================================
void int_isr(void) __interrupt
{
  __asm;
  push

  __endasm;

  if(TC0IE)
  {
    if(TC0IF)
    {
      TC0IF = 0;
      if(--R_500US_COUNT==0)
      {
        R_500US_COUNT = T_500US_C_Init_DF;
        bT_500US_F = 1;

        if(--R_10MS_COUNT==0)
        {
          R_10MS_COUNT = T_10MS_C_Init_DF;
          bT_10MS_F = 1;
        }
      }
    }
  }

  __asm
  pop

  __endasm;
}

//================================================================================
void IO_Init(void)
{
  //IO_init
  OEA = Bin(11111111);  //1:output  0:input
  IOA = 0;
  OEB = Bin(11111111);  //1:output  0:input
  IOB = 0;
  OEC = Bin(11111111);  //1:output  0:input
  IOC = 0;

}

//================================================================================
void T0_Init(void)
{
  TC0CH = 0;
  TC0CL = T0_LOAD_C_Init;

  T0CR = Bin(10001100);
  TC0IE = 1;
}

//================================================================================
void InitalRAM()
{
  __asm
  clrr    FSR0          //0x00
  _ClrRam_loop:
  clrr    INDF0
  incr    FSR0,r
  movr    FSR0,a
  jcmpai  low(0x7f+1)   //0x7f+1
  goto    _ClrRam_loop
  __endasm;
	
R_500US_COUNT  = T_500US_C_Init_DF;
R_10MS_COUNT  = T_10MS_C_Init_DF;	
	
}


/*********************************END OF FILE************************************/

